* This file is called by aser_polcycle.do
* Produces Figure 3, Figure 4, Figure 5


*****************
**** READING **** (Figure 3)
*****************

**** Public sector schools

* Graph 1: single years of treatment and Graph 2: grouped years

*** Graph 1
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg readz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==0 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results1, replace)
use /tera1/ASER/results1, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Govt. schools: Year effects") legend(off) 
graph save /tera1/ASER/Event1,replace

*** Graph 2
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg readz aft bef female yd* agd5-agd12 if schpri==0 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results2, replace)
use /tera1/ASER/results2, clear
drop if _n>2
replace label="+1" in 1
replace label="-1" in 2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing  -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Govt. schools: Grouped years") legend(off) 
graph save /tera1/ASER/Event2,replace

**** Private sector schools

* Graph 3: single years of treatment and Graph 4: grouped years

*** Graph 3
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg readz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==1 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results3, replace)
use /tera1/ASER/results3, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Private schools: Year effects") legend(off) 
graph save /tera1/ASER/Event3,replace

*** Graph 4
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg readz aft bef female yd* agd5-agd12 if schpri==1 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results4, replace)
use /tera1/ASER/results4, clear
drop if _n>2
replace label="+1" in 1
replace label="-1" in 2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
*foreach var of varlist label estimate stderr dof t p min95 max95 parm {
*replace `var'=`var'[_n-1] if _n==5
*replace `var'=`var'[_n-1] if _n==4
*}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing  -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Private schools: Grouped years") legend(off) 
graph save /tera1/ASER/Event4,replace

cd /tera1/ASER/
gr combine Event1.gph Event2.gph Event3.gph Event4.gph, col(2)
graph export /tera1/ASER/Events_reading.tif,replace

***************
**** MATHS **** (Figure 4)
***************

**** Public sector schools

* Graph 5: single years of treatment and Graph 6: grouped years

*** Graph 5
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg mathz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==0 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results5, replace)
use /tera1/ASER/results5, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Govt. schools: Year effects") legend(off) 
graph save /tera1/ASER/Event5,replace

*** Graph 6
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg mathz aft bef female yd* agd5-agd12 if schpri==0 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results6, replace)
use /tera1/ASER/results6, clear
drop if _n>2
replace label="+1" in 1
replace label="-1" in 2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing  -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Govt. schools: Grouped years") legend(off) 
graph save /tera1/ASER/Event6,replace

**** Private sector schools

* Graph 7: single years of treatment and Graph 8: grouped years

*** Graph 7
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg mathz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==1 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results7, replace)
use /tera1/ASER/results7, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Private schools: Year effects") legend(off) 
graph save /tera1/ASER/Event7,replace

*** Graph 8
use /tera1/ASER/aserindiv05-12_reg.dta,clear
quietly xtreg mathz aft bef female yd* agd5-agd12 if schpri==1 & class==4, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results8, replace)
use /tera1/ASER/results8, clear
drop if _n>2
replace label="+1" in 1
replace label="-1" in 2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
*foreach var of varlist label estimate stderr dof t p min95 max95 parm {
*replace `var'=`var'[_n-1] if _n==5
*replace `var'=`var'[_n-1] if _n==4
*}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing  -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Private schools: Grouped years") legend(off) 
graph save /tera1/ASER/Event8,replace

cd /tera1/ASER/
gr combine Event5.gph Event6.gph Event7.gph Event8.gph, col(2)
graph export /tera1/ASER/Events_maths.tif,replace

***********************************************
*** Testing for larger effects by subsample *** (Figure 5)
***********************************************

* Split districts in half within each state, by school size
use /tera1/ASER/aserindiv05-12_reg.dta,clear
egen dmtchpos2=mean(mtchpos2) if schpri==0 & class==4,by(state) 
gen xsmall=1 if mtchpos2<dmtchpos2
replace xsmall=0 if mtchpos2>dmtchpos2 & mtchpos2!=.

*Reading, smaller schools 
xtreg readz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==0 & class==4 & xsmall==1, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results_r1, replace)
use /tera1/ASER/results_r1, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Districts with small school size") legend(off) 
graph save /tera1/ASER/Event_r1,replace


*Reading, larger schools
use /tera1/ASER/aserindiv05-12_reg.dta,clear
egen dmtchpos2=mean(mtchpos2) if schpri==0 & class==4,by(state) 
gen xsmall=1 if mtchpos2<dmtchpos2
replace xsmall=0 if mtchpos2>dmtchpos2 & mtchpos2!=.

xtreg readz ed1 ed2 ed3 ed4 female yd* agd5-agd12 if schpri==0 & class==4 & xsmall==0, fe cluster(state_code)
parmest, label list(parm label estimate min* max* p) saving(/tera1/ASER/results_r2, replace)
use /tera1/ASER/results_r2, clear
drop if _n>4
replace label="+1" in 1
replace label="+2" in 2
replace label="-2" in 3
replace label="-1" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==5
}
replace label="0" if _n==5

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Districts with large school size") legend(off) 
graph save /tera1/ASER/Event_r2,replace

