*
* Append together results from all elections and manipulate the file to usable form
* modified 16.9.2014 - average caste + reservations
*
* DEPENDS ON:
* All2008coded1.csv All2008coded2.csv
* All2011coded1.csv All2011coded2.csv
* All2012coded1.csv All2012coded2.csv
* {year}-{statecd}.dta
* /IndiaTeachers/AssemblyElecBoundaries/CodedToExcel2000-2012.csv (constituency-district correspondence)

* CREATES:
* All2008coded.dta All2011coded.dta All2012coded.dta (intermediate files)
* * x{year}-{statecd}.dta
* x1999-2012_AsElec.dta
* x1999-2012_AsElec2.dta
* /IndiaTeachers/AssemblyElecBoundaries/ac-dist2000-2012.dta
* x1999-2012_AsElec2_dists.dta (file with constituencies, districts and election results)
* /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elec.dta (indicates which states had elections over 1999-2012)
* /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix.dta

cd /tera1/IndiaTeachers/AssemblyElec

** First deal with results obtained from the Excel files (2008,2011,2012)

* The 2008 data
clear
insheet using All2008coded2.csv,delimiter(";")
gen state2="MG" if st_code=="S15"
replace state2="NL" if st_code=="S17"
replace state2="TP" if st_code=="S23"
replace state2="KT" if st_code=="S10"
replace state2="CH" if st_code=="S26"
replace state2="JK" if st_code=="S09"
replace state2="MP" if st_code=="S12"
replace state2="MZ" if st_code=="S16"
replace state2="DE" if st_code=="U05"
replace state2="RS" if st_code=="S20"
drop st_* month 
rename ac_no cnr
rename tot_electors electors
rename tot_voters votes
drop poll_percent ac_name 
sort year state2 cnr
saveold All2008coded2.dta,replace

clear
insheet using All2008coded1.csv,delimiter(";")
gen state2="MG" if st_code=="S15"
replace state2="NL" if st_code=="S17"
replace state2="TP" if st_code=="S23"
replace state2="KT" if st_code=="S10"
replace state2="CH" if st_code=="S26"
replace state2="JK" if st_code=="S09"
replace state2="MP" if st_code=="S12"
replace state2="MZ" if st_code=="S16"
replace state2="DE" if st_code=="U05"
replace state2="RS" if st_code=="S20"
drop st_* month 
rename ac_no cnr
rename dist_name dist
rename ac_name cname
replace cname=upper(cname)
gen res_st = ac_type=="ST"
gen res_sc = ac_type=="SC"
drop ac_type
rename cand_name pname 
rename cand_sex psex
rename cand_category pcaste
rename cand_age page
rename partyabbre pparty
rename totvotpoll pvotes
rename position prank
sort year state2 cnr
merge year state2 cnr using All2008coded2.dta
* MG 37 has no election for some reason. Assume uncontested.
gen uncon = _merge==2
drop _merge
destring pvotes,replace
destring page,replace
replace dist=trim(upper(dist))
rename dist dist08
label var dist08 "District-AC corresp. in 2008 elections"
saveold All2008coded.dta,replace

* 2011
clear
insheet using All2011coded2.csv
gen state2="AS" if st_code=="S03"
replace state2="KL" if st_code=="S11"
replace state2="TN" if st_code=="S22"
replace state2="WB" if st_code=="S25"
replace state2="PY" if st_code=="U07"
drop st_* 
rename ac_no cnr
rename tot_electors electors
rename tot_voters votes
drop poll_percent ac_name 
gen year=2011
sort year state2 cnr
saveold All2011coded2.dta,replace

clear
insheet using All2011coded1.csv
gen state2="AS" if st_code=="S03"
replace state2="KL" if st_code=="S11"
replace state2="TN" if st_code=="S22"
replace state2="WB" if st_code=="S25"
replace state2="PY" if st_code=="U07"
drop st_* month 
rename ac_no cnr
rename dist_name dist
rename ac_name cname
replace cname=upper(cname)
gen res_st = ac_type=="ST"
gen res_sc = ac_type=="SC"
drop ac_type
rename cand_name pname 
rename cand_sex psex
rename cand_category pcaste
rename cand_age page
rename partyabbre pparty
rename totvotpoll pvotes
rename position prank
sort year state2 cnr
merge year state2 cnr using All2011coded2.dta
drop _merge
replace dist=trim(upper(dist))
rename dist dist11
label var dist11 "District-AC corresp. in 2011 elections"
saveold All2011coded.dta,replace

* 2012
clear
insheet using All2012coded2.csv
gen state2="GO" if st_code=="S05"
replace state2="MR" if st_code=="S14"
replace state2="PB" if st_code=="S19"
replace state2="UP" if st_code=="S24"
replace state2="UT" if st_code=="S28"
replace state2="GU" if st_code=="S06"
replace state2="HP" if st_code=="S08"
drop st_* 
rename ac_no cnr
rename tot_electors electors
rename tot_voters votes
drop poll_percent ac_name 
sort year state2 cnr
saveold All2012coded2.dta,replace

clear
insheet using All2012coded1.csv
gen state2="GO" if st_code=="S05"
replace state2="MR" if st_code=="S14"
replace state2="PB" if st_code=="S19"
replace state2="UP" if st_code=="S24"
replace state2="UT" if st_code=="S28"
replace state2="GU" if st_code=="S06"
replace state2="HP" if st_code=="S08"
drop st_* month 
rename ac_no cnr
rename dist_name dist
rename ac_name cname
replace cname=upper(cname)
gen res_st = ac_type=="ST"
gen res_sc = ac_type=="SC"
drop ac_type
rename cand_name pname 
rename cand_sex psex
rename cand_category pcaste
rename cand_age page
rename partyabbre pparty
rename totvotpoll pvotes
rename position prank
sort year state2 cnr
merge year state2 cnr using All2012coded2.dta
drop _merge
replace dist=trim(upper(dist))
rename dist dist12
label var dist12 "District-AC corresp. in 2012 elections"
saveold All2012coded.dta,replace

*** ALL OTHER YEARS 1999-2007 AND 2009-2010

#delimit ;

local files "1999-AP.dta 2001-AS.dta  2002-UP.dta  2004-AP.dta  2006-KL.dta  2007-UT.dta
1999-AR.dta  2001-KL.dta  2002-UT.dta  2004-AR.dta  2006-PY.dta  2009-AP.dta
1999-GO.dta  2001-PY.dta  2003-CH.dta  2004-KT.dta  2006-TN.dta  2009-AR.dta
1999-KT.dta  2001-TN.dta  2003-DE.dta  2004-MH.dta  2006-WB.dta  2009-HY.dta
1999-MH.dta  2001-WB.dta  2003-HP.dta  2004-OR.dta  2007-GO.dta  2009-JH.dta
1999-SK.dta  2002-GO.dta  2003-MP.dta  2004-SK.dta  2007-GU.dta  2009-MH.dta
2000-BH.dta  2002-GU.dta  2003-MZ.dta  2005-BH_v2.dta  2007-HP.dta  2009-OR.dta
2000-HY.dta  2002-JK.dta  2003-NL.dta  2005-HY_v2.dta  2007-MR.dta  2009-SK.dta
2000-MR.dta  2002-MR.dta  2003-MG.dta  2003-RS.dta  2005-JH_v2.dta  2007-PB.dta
2000-OR.dta  2002-PB.dta  2003-TP.dta  2006-AS.dta  2007-UP.dta All2008coded.dta 2010-BH.dta All2011coded.dta All2012coded.dta";

#delimit cr

*
* Create smaller files with only the key info

foreach var of local files {
clear
use `var'
* Keep only winner and runner up
keep if prank<=2
sort year state2 cnr prank
gen voteshare=pvotes/votes
gen margin=(pvotes-pvotes[_n+1])/votes if cnr==cnr[_n+1]
gen loserparty=pparty[_n+1] if cnr==cnr[_n+1]
gen losersex=psex[_n+1] if cnr==cnr[_n+1]
keep if prank==1
capture destring page,replace
label var voteshare "Share of votes to winner"
label var margin "Winning margin (as share of all votes)"
label var loserparty "Party of the losing candidate"
label var losersex "Sex of the losing candidate"
drop prank
saveold x`var',replace
}


*** APPEND ALL ***
clear

#delimit ;

local files "2001-AS.dta  2002-UP.dta  2004-AP.dta  2006-KL.dta  2007-UT.dta
1999-AR.dta  2001-KL.dta  2002-UT.dta  2004-AR.dta  2006-PY.dta  2009-AP.dta
1999-GO.dta  2001-PY.dta  2003-CH.dta  2004-KT.dta  2006-TN.dta  2009-AR.dta
1999-KT.dta  2001-TN.dta  2003-DE.dta  2004-MH.dta  2006-WB.dta  2009-HY.dta
1999-MH.dta  2001-WB.dta  2003-HP.dta  2004-OR.dta  2007-GO.dta  2009-JH.dta
1999-SK.dta  2002-GO.dta  2003-MP.dta  2004-SK.dta  2007-GU.dta  2009-MH.dta
2000-BH.dta  2002-GU.dta  2003-MZ.dta  2005-BH_v2.dta  2007-HP.dta  2009-OR.dta
2000-HY.dta  2002-JK.dta  2003-NL.dta  2005-HY_v2.dta  2007-MR.dta  2009-SK.dta
2000-MR.dta  2002-MR.dta  2003-MG.dta  2003-RS.dta  2005-JH_v2.dta  2007-PB.dta
2000-OR.dta  2002-PB.dta  2003-TP.dta  2006-AS.dta  2007-UP.dta All2008coded.dta 2010-BH.dta All2011coded.dta All2012coded.dta";

#delimit cr

use x1999-AP.dta

foreach var of local files {
append using x`var'
}
label var uncon "Uncontested election"
replace state="Jharkand" if state=="Jharkhand"
replace pcaste=trim(pcaste)
replace pparty=trim(pparty)
replace loserparty=trim(loserparty)
sort year state2 cnr
saveold x1999-2012_AsElec.dta,replace

* CHANGE cname to match better with DISE constituency file
gen cname2=upper(trim(cname))
* Remove number from beginning, if any
* replace '-' with a space to have number as separate word
replace cname2=subinstr(cname2," - "," ",.) 
replace cname2=subinstr(cname2,"-"," ",.) 
replace cname2=subinstr(cname2," (","(",.)
replace cname2=subinstr(cname2,")","",.)
replace cname2=subinstr(cname2,"("," ",.)
replace cname2=subinstr(cname2,".","",.)
replace cname2=subinstr(cname2," / "," ",.) 
replace cname2=subinstr(cname2,"/"," ",.) 
replace cname2=trim(cname2)

* ALPHABETICAL ORDER NUMBER (By state)
* Constituency number by state based on alphabetical order
* NOTE: The number may not match consistently across years (this needs to be checked)
sort state2 year cname2
gen anr = 1 if (state2~=state2[_n-1]) | (year~=year[_n-1])
replace anr=anr[_n-1]+1 if anr==.

sort state2 year cname2
saveold x1999-2012_AsElec2.dta,replace

*********************
* MONTH OF ELECTION *
*********************
* dataset created here based on info in /IndiaTeachers/Turnover/India_state_election_dates.odt
clear
set obs 82
gen year=1999 in 1/6
replace year=2000 in 7/10
replace year=2001 in 11/15
replace year=2002 in 16/22
replace year=2003 in 23/31
replace year=2004 in 32/37
replace year=2005 in 38/40
replace year=2006 in 41/45
replace year=2007 in 46/52
replace year=2008 in 53/62
replace year=2009 in 63/69
replace year=2010 in 70
replace year=2011 in 71/75
replace year=2012 in 76/82
local stat "AR AP KT MH SK GO BH HY MR OR AS KL PY TN WB GU JK GO MR PB UP UT CH DE MP MZ RS HP MG NL TP MH AR AP KT OR SK BH JH HY AS KL PY TN WB GU HP GO UP MR PB UT CH MP MZ DE RS JK KT NL MG TP AR JH HY MH AP OR SK BH AS KL TN WB PY GU HP GO MR PB UP UT"
gen state2=""
gen i=1
foreach st of local stat {
replace state2="`st'" if _n==i 
replace i=i+1
}
local mont "10 10 10 10 10 6 2 2 2 2 5 5 5 5 5 12 10 5 2 2 2 2 11 11 11 11 11 2 2 2 2 10 10 4 4 4 5 10 11 2 4 4 5 5 4 12 11 6 4 2 2 2 11 11 12 11 12 11 5 3 3 3 10 10 10 10 4 4 4 10 4 4 4 4 4 12 12 1 1 1 1 1" 
gen month=.
replace i=1
foreach mo of local mont {
replace month=`mo' if _n==i 
replace i=i+1
}
drop i
sort state2 year month
saveold electionmonths.dta,replace

use x1999-2012_AsElec2.dta,clear
drop month
sort state2 year 
merge state2 year using electionmonths.dta,uniqusing
tab _merge
drop _merge
saveold x1999-2012_AsElec2.dta,replace

***********************************
* MERGE DISE DISTRICT IDENTIFIERS *
***********************************

* Want a data that specifies politics for year-district cells.
* Using data: x1999-2012_AsElec2 , Merging data: CodedToExcel2000-2012
* Then collapse to district level

* Merge by state and cnr
* The DISE code is in /AssemblyElecBoundaries/CodedToExcel2000-2012.ods
* Its stata version is CodedToExcel2000-2012.csv 
* Some potential issues:
* First make sure state codes same
* Some cnrs in merging data might be duplicate due to AC being in 2 districts.
clear
* This File specifies AC-district(DISE code) correspondence, nothing else.
insheet using /tera1/IndiaTeachers/AssemblyElecBoundaries/CodedToExcel2000-2012.csv, delimiter(";")
drop v9-v11
replace notes=v7+notes
drop v7
replace distcd="" if distcd=="?"
destring distcd,replace
gen state2=substr(state,1,2)
drop state
replace ac_name=trim(ac_name)
replace dist=trim(dist)
replace notes=trim(notes)
sort year state2 dist ac_n
replace distcd=distcd[_n-1] if dist==dist[_n-1] & distcd==.
order state2 year ac_n ac_name distcd dist notes
label var state2 "state shorthand"
label var ac_n "Official A.C. number"
label var ac_name "Assembly constit. name"
label var distcd "DISE 2009 District code"
label var dist "District name"
label var notes "notes on DISE code"
* The district codings might need still some checking..
sort year state2 ac_n
saveold /tera1/IndiaTeachers/AssemblyElecBoundaries/ac-dist2000-2012.dta,replace

clear
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2.dta
rename cnr ac_n
sort year state2 ac_n
merge year state2 ac_n using /tera1/IndiaTeachers/AssemblyElecBoundaries/ac-dist2000-2012.dta
tab state2 year if _merge==1
tab state2 year if _merge==2
* only 1999 from using not merging, as assumed, Also AR for which no delimitation 2008 took place (not included here)
* SK 2001 one dist (doesn't have a distcd) - sangha, north ac_n=32
drop if _merge==2
drop _merge
* 1999 distcd for AP, AR, KT, MH and SK - can use the same as in 2004 
sort state2 ac_n year
replace distcd=distcd[_n+1] if state2==state2[_n+1] & ac_n==ac_n[_n+1] & distcd==. & year==1999 & year[_n+1]==2004 & (state2=="AP"|state2=="AR"|state2=="KT"|state2=="MH"|state2=="SK")
* 1999 distcd for GO -  can use the same as in 2002 [added for revision]
replace distcd=distcd[_n+1] if state2==state2[_n+1] & ac_n==ac_n[_n+1] & distcd==. & year==1999 & year[_n+1]==2002 & state2=="GO"

******************************
* Create alternative timings *
******************************
* This is to test alternative hypothese of the timing of elections on school variables.
* H0: "Improvements in 2001/2 acad yr, visible in 2002/3 data (collected in Sept), are aimed by politicians for elections in calendar year 2002"
* H1: " -..- , are aimed by politicians for elections in Oct-Dec01 and Jan-Sep02"
* H2: " -..- , are aimed by politicians for elections in Apr-Dec02 and Jan-Mar03"
* H3: " -..- , are aimed by politicians for elections in Jul-Dec02 and Jan-Jun03"
* All are plausible. H0 simplest though.
* In H0, 2001 elections match with 2002/3 school data, the current year is interpreted as the LAST pre-election year
*  -> in 2002 data we have the outcome of the next election
* for H1,H2,H3 need to modify the years of elections slightly to adjust the 'political year'

* Set 'political year' to run from Oct to Sep
gen yearh1=year
replace yearh1=year+1 if month>=10 & month<=12
* Set 'political year' to run from Apr to Mar
gen yearh2=year
replace yearh2=year-1 if month>=1 & month<=3
* Set 'political year' to run from Jul to Jun
gen yearh3=year
replace yearh3=year-1 if month>=1 & month<=6
label var yearh1 "Political year set to Oct-Sep (1Q earlier)"
label var yearh2 "Political year set to Apr-Mar (1Q later)" 
label var yearh3 "Political year set to Jul-Jun (2Q later)" 
saveold /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,replace

*********************************
* FILE FOR STATE-YEAR ELECTIONS *
*********************************

use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
keep state2 year
sort state2 year
drop if state2==state2[_n-1] & year==year[_n-1]
saveold /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elec.dta,replace
*h1
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
keep state2 yearh1
sort state2 yearh1
drop if state2==state2[_n-1] & yearh1==yearh1[_n-1]
saveold /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech1.dta,replace
*h2
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
keep state2 yearh2
sort state2 yearh2
drop if state2==state2[_n-1] & yearh2==yearh2[_n-1]
saveold /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech2.dta,replace
*h3
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
keep state2 yearh3
sort state2 yearh3
drop if state2==state2[_n-1] & yearh3==yearh3[_n-1]
saveold /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech3.dta,replace

********************************
* CONSTRUCT POLITICAL OUTCOMES *
********************************
* Aggragate AC results to district and state levels

clear
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta
sort year distcd

* Ruling party in each State-Year (defined by most won seats)
*   Ignoring coalitions. Undefined for JH2009, draw between JMM-BJP -> JMM formed the coalition 
egen sparty=mode(pparty),by(year state2)
replace sparty="JMM" if state2=="JH" & year==2009
*Bihar-Jharkhand split: Rename Pre-Jharkhand districts of Bihar as being 'Jharkhand;, so that there is continuity in results
* The distcd codes are already in that way
replace state2="JH" if state2=="BH" & year==2000 & distcd>2000

* Proportion of seats that are aligned to ruling party at state and district
gen ali= pparty==sparty
egen saligns=mean(ali),by(year state2)
sort state2 year
su saligns if year~=year[_n-1]
* now 83 state elections
egen aligns=mean(ali),by(year distcd)
* New ruler in the state (the largest party changes)
gen newrule=1 if state2==state2[_n-1] & year~=year[_n-1] & sparty~=sparty[_n-1]
replace newrule=0 if state2==state2[_n-1] & year~=year[_n-1] & sparty==sparty[_n-1]
replace newrule=newrule[_n-1] if year==year[_n-1] & state2==state2[_n-1] & newrule==.
* Margin of victory (or loss) for aligning seats
gen alimargin=margin if pparty==sparty
replace alimargin=-margin if loserparty==sparty
* Fraction of ACs in which aligned party won marginally (Clots-Figueras IV 1)
gen CFiv1_ = alimargin>0 & alimargin<=0.035
egen CFiv1=mean(CFiv1_),by(year distcd)
* Fraction of ACs in which election win was marginal (Clots-Figueras IV 2)
gen CFiv2_ = alimargin>=-0.035 & alimargin<=0.035
egen CFiv2=mean(CFiv2_),by(year distcd)
* Alternative margin 0.02
gen CFiv1b_ = alimargin>0 & alimargin<=0.02
egen CFiv1b=mean(CFiv1b_),by(year distcd)
gen CFiv2b_ = alimargin>=-0.02 & alimargin<=0.02
egen CFiv2b=mean(CFiv2b_),by(year distcd)
* Turnout
ge turnout=votes/electors
drop ali CF*_ 

** Compute change in the popularity of the largest party within district
** as measured by the proportion assembly seats
* modal party
egen dbig=mode(pparty),by(distcd year) minmode
* seat share of the modal party
gen dbigs=0 if pparty!=dbig
replace dbigs=1 if pparty==dbig
egen dbigsh=mean(dbigs),by(distcd year)
** Compute the change in the popularity of this party in the next election
sort state2 distcd year ac_n 
* br state2 ac_n distcd year pparty dbig dbigs dbigsh
gen pastbig=dbig[_n-1] if distcd==distcd[_n-1] & year>year[_n-1] 
replace pastbig=pastbig[_n-1] if pastbig=="" & distcd==distcd[_n-1] & year==year[_n-1]
gen dbigs2=0 if pparty!=pastbig
replace dbigs2=1 if pparty==pastbig
egen dbigsh2=mean(dbigs2),by(distcd year)
* Change in % of seats:
gen dbigch=dbigsh2-dbigsh[_n-1] if distcd==distcd[_n-1] & year>year[_n-1]
replace dbigch=dbigch[_n-1] if dbigch==. & distcd==distcd[_n-1] & year==year[_n-1]

* Compute % of seats in district that change hands (party) [IS IT NEEDED?]
* Due to delimitation, this can be done only either for changes before or after delimitation. Changes missing if delimitation in between!
sort state2 ac_n year
* pre-delimitation changes
gen change=0 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty!=pparty[_n-1]
* post-delimitation chances (none since no state has had elections in 2008 & 2013
replace change=0 if ac_n==ac_n[_n-1] & year>=2008 & year[_n-1]>=2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & year>=2008 & year[_n-1]>=2008 & pparty!=pparty[_n-1]
egen dchange=mean(change),by(distcd year)

* Save information on the prportion of tight elections
*count if margin>0.035  & margin~=.& year>=2000 & year<=2012
*count if margin<=0.035 & year>=2000 & year<=2012
*count if margin~=. & year>=2000 & year<=2012
*8225,2386,10611
*histogram margin if year>=2000 & year<=2012, start(0) width(0.005)
*graph save 

* Balance at treshold
gen pinc= pparty=="INC"
gen pbjp= pparty=="BJP"
label var pinc "winning party INC dummy"
label var pbjp "winning party BJP dummy"
*set logtype text
*log using /tera1/IndiaTeachers/AssemblyElec/tresholdbalance.txt,replace
*de res_sc res_st electors turnout pinc pbjp
** marginal alignments
*su res_sc res_st electors turnout pinc pbjp if alimargin>0 & alimargin<0.035 
** marginal nonalignments
*su res_sc res_st electors turnout pinc pbjp if alimargin>-0.035 & alimargin<0
** tests
*prtesti 988 .1467611 870 .1103448
*prtesti 988 .1072874 870 .0908046
*ttesti 988 169944.4 81848.29 868 166971.4 71851.58
*prtesti 988 .6898689 868 .6925433
*prtesti 988 .312753 870 .3287356
*prtesti 988 .208502 870 .1448276
*log close

* Test politician gender
gen fem=1 if psex=="F"
replace fem=0 if psex=="M"
egen fems=mean(fem),by(year distcd)
* Margin of victory (or loss) female candidates
gen fmargin=margin if psex=="F" & losersex=="M"
replace fmargin=-margin if losersex=="F" & psex=="M"
* Fraction of ACs in which female won marginally 
gen ivfem1_ = fmargin>0 & fmargin<=0.035
egen ivfem1=mean(ivfem1_),by(year distcd)
* Fraction of ACs in which gender was marginal 
gen ivfem2_ = fmargin>=-0.035 & fmargin<=0.035
egen ivfem2=mean(ivfem2_),by(year distcd)
drop ivfem?_
* Fraction of ACs in which female won marginally 
gen ivfem1_ = fmargin>0 & fmargin<=0.05
egen ivfem15=mean(ivfem1_),by(year distcd)
* Fraction of ACs in which gender was marginal 
gen ivfem2_ = fmargin>=-0.05 & fmargin<=0.05
egen ivfem25=mean(ivfem2_),by(year distcd)
drop ivfem?_
* Fraction of ACs in which female won marginally 
gen ivfem1_ = fmargin>0 & fmargin<=0.07
egen ivfem17=mean(ivfem1_),by(year distcd)
* Fraction of ACs in which gender was marginal 
gen ivfem2_ = fmargin>=-0.07 & fmargin<=0.07
egen ivfem27=mean(ivfem2_),by(year distcd)
drop ivfem?_

* Politicians caste
* Reserved seats
egen resst=mean(res_st),by(year distcd)
egen ressc=mean(res_sc),by(year distcd)
gen p_sc=pcaste=="SC"
gen p_st=pcaste=="ST"
egen pst=mean(p_st) if year>2003,by(year distcd)
egen psc=mean(p_sc) if year>2003,by(year distcd)
drop p_sc p_st

* Collapse to district level 
*  first aggregate assembly level variables as required
* ok to take average since costituencies have appx the same population by design
egen dturnout=mean(turnout),by(distcd year)
* Alternative uses pre '05 turnouts - take newest for each state
gen dturnoutpre_=turnout if year>2000 & year<=2004
replace dturnoutpre_=turnout if year==2000 & (state2=="BH"|state2=="JH"|state2=="HY")
egen dturnoutpre=mean(dturnoutpre_),by(distcd year)
replace dturnoutpre=. if distcd==.
drop dturnoutpre_
keep  year state state2 distcd dist sparty aligns saligns newrule dchange dbigch CFiv1 CFiv2 CFiv1b CFiv2b dturnout* month fems ivfem* ressc resst psc pst
sort year state2 distcd
keep if distcd~=distcd[_n-1] 

label var sparty "State's leading party by seats"
label var aligns "% seats in district politically aligned with state leader"
label var saligns "% seats in state politically aligned with state leader"
label var newrule "Current state leading party is new"
label var CFiv1 "% ACs where aligned party won marginally (max 3.5%)"
label var CFiv2 "% ACs where alignment outcome was a close call (-3.5/3.5%)"
label var CFiv1b "% ACs where aligned party won marginally (max 2%)"
label var CFiv2b "% ACs where alignment outcome was a close call (-2/2%)"
label var dturnout "Avg Voter turnout in district (across ACs)"
label var dturnoutpre "Voter turnout in district (across ACs), 2000-04"
label var dchange "% of seats in district that change party (only pre-delimitation)"
label var dbigch "% change in seats held by the largest party in district" 
label var fems "% of seats in district won by women"
label var ivfem1 "% ACs where female won marginally (max 3.5%)"
label var ivfem2 "% ACs where gender outcome was a close call (-3.5/3.5%)"
label var ivfem15 "% ACs where female won marginally (max 5%)"
label var ivfem25 "% ACs where gender outcome was a close call (-5/5%)"
label var ivfem17 "% ACs where female won marginally (max 7%)"
label var ivfem27 "% ACs where gender outcome was a close call (-7/7%)"
label var ressc "% of seats in district reserved to SC"
label var resst "% of seats in district reserved to ST"
label var psc "% of seats in district won by SC"
label var pst "% of seats in district won by ST"

** 1st stages at distict level 
*quietly tab year,ge(yd)
*set logtype text
*log using /tera1/IndiaTeachers/Turnover/Political_output/1stStage_districts.txt,replace
*reg aligns CFiv1 CFiv2
*areg aligns CFiv1 CFiv2 yd*,absorb(distcd)
*reg fems ivfem1 ivfem2
*areg fems ivfem1 ivfem2 yd*,absorb(distcd)
*log close
*drop yd*

sort state2 distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics.dta,replace

*** FOR H1: POLITICAL YEAR OCT-SEP ***
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
sort yearh1 distcd

egen sparty=mode(pparty),by(yearh1 state2)
replace sparty="JMM" if state2=="JH" & yearh1==2009
replace state2="JH" if state2=="BH" & yearh1==2000 & distcd>2000
* Proportion of seats that are aligned to ruling party at state and district
gen ali= pparty==sparty
egen saligns=mean(ali),by(yearh1 state2)
sort state2 yearh1
su saligns if yearh1~=yearh1[_n-1]

egen aligns=mean(ali),by(yearh1 distcd)
* New ruler in the state (largest party changes)
gen newrule=1 if state2==state2[_n-1] & yearh1~=yearh1[_n-1] & sparty~=sparty[_n-1]
replace newrule=0 if state2==state2[_n-1] & yearh1~=yearh1[_n-1] & sparty==sparty[_n-1]
replace newrule=newrule[_n-1] if yearh1==yearh1[_n-1] & state2==state2[_n-1] & newrule==.
* Turnout
ge turnout=votes/electors
drop ali 

** Compute change in the popularity of the largest party within district
** as measured by the proportion assembly seats
* modal party
egen dbig=mode(pparty),by(distcd yearh1) minmode
* seat share of the model party
gen dbigs=0 if pparty!=dbig
replace dbigs=1 if pparty==dbig
egen dbigsh=mean(dbigs),by(distcd yearh1)
** Compute the change in the popularity of this party in the next election
sort state2 distcd yearh1 ac_n 
gen pastbig=dbig[_n-1] if distcd==distcd[_n-1] & yearh1>yearh1[_n-1] 
replace pastbig=pastbig[_n-1] if pastbig=="" & distcd==distcd[_n-1] & yearh1==yearh1[_n-1]
gen dbigs2=0 if pparty!=pastbig
replace dbigs2=1 if pparty==pastbig
egen dbigsh2=mean(dbigs2),by(distcd yearh1)
* Change in % of seats:
gen dbigch=dbigsh2-dbigsh[_n-1] if distcd==distcd[_n-1] & yearh1>yearh1[_n-1]
replace dbigch=dbigch[_n-1] if dbigch==. & distcd==distcd[_n-1] & yearh1==yearh1[_n-1]

* Compute % of seats in district that change hands (party)
* Due to delimitation, this can be done only either for changes before or after delimitation. Changes missing if delimitation in between!
sort state2 ac_n yearh1
* pre-delimitation changes
gen change=0 if ac_n==ac_n[_n-1] & yearh1<2008 & yearh1[_n-1]<2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & yearh1<2008 & yearh1[_n-1]<2008 & pparty!=pparty[_n-1]
* post-delimitation chances 
replace change=0 if ac_n==ac_n[_n-1] & yearh1>=2008 & yearh1[_n-1]>=2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & yearh1>=2008 & yearh1[_n-1]>=2008 & pparty!=pparty[_n-1]
egen dchange=mean(change),by(distcd yearh1)

gen pinc= pparty=="INC"
gen pbjp= pparty=="BJP"
label var pinc "winning party INC dummy"
label var pbjp "winning party BJP dummy"

* Politician gender
gen fem=1 if psex=="F"
replace fem=0 if psex=="M"
egen fems=mean(fem),by(yearh1 distcd)
* Politicians caste
* Reserved seats
egen resst=mean(res_st),by(yearh1 distcd)
egen ressc=mean(res_sc),by(yearh1 distcd)
gen p_sc=pcaste=="SC"
gen p_st=pcaste=="ST"
egen pst=mean(p_st) if yearh1>2003,by(yearh1 distcd)
egen psc=mean(p_sc) if yearh1>2003,by(yearh1 distcd)
drop p_sc p_st

* Collapse to district level 
egen dturnout=mean(turnout),by(distcd yearh1)
* Alternative uses pre '05 turnouts - take newest for each state
gen dturnoutpre_=turnout if yearh1>2000 & yearh1<=2004
replace dturnoutpre_=turnout if yearh1==2000 & (state2=="BH"|state2=="JH"|state2=="HY")
egen dturnoutpre=mean(dturnoutpre_),by(distcd yearh1)
replace dturnoutpre=. if distcd==.
drop dturnoutpre_
keep  yearh1 state state2 distcd dist sparty aligns saligns newrule dchange dbigch dturnout* month fems ressc resst psc pst
sort yearh1 state2 distcd
keep if distcd~=distcd[_n-1] 

label var aligns "% seats in district politically aligned with state leader"
label var dturnout "Avg Voter turnout in district (across ACs)"
rename yearh1 year
rename aligns alignsh1
rename saligns salignsh1
rename sparty spartyh1
rename newrule newruleh1
rename dbigch dbigchh1
rename dchange dchangeh1
rename dturnout dturnouth1
sort state2 distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h1.dta,replace

*** FOR H2: POLITICAL YEAR APR-MAR *** [REMOVE - NOT USED]
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
sort yearh2 distcd
egen sparty=mode(pparty),by(yearh2 state2)
replace sparty="JMM" if state2=="JH" & yearh1==2009
gen ali= pparty==sparty
egen saligns=mean(ali),by(yearh2 state2)
sort state2 yearh2
gen newrule=1 if state2==state2[_n-1] & yearh2~=yearh2[_n-1] & sparty~=sparty[_n-1]
replace newrule=0 if state2==state2[_n-1] & yearh2~=yearh2[_n-1] & sparty==sparty[_n-1]
replace newrule=newrule[_n-1] if yearh2==yearh2[_n-1] & state2==state2[_n-1] & newrule==.
egen aligns=mean(ali),by(yearh2 distcd)
gen alimargin=margin if pparty==sparty
replace alimargin=-margin if loserparty==sparty
gen CFiv1_ = alimargin>0 & alimargin<=0.035
egen CFiv1=mean(CFiv1_),by(yearh2 distcd)
gen CFiv2_ = alimargin>=-0.035 & alimargin<=0.035
egen CFiv2=mean(CFiv2_),by(yearh2 distcd)
gen CFiv1b_ = alimargin>0 & alimargin<=0.02
egen CFiv1b=mean(CFiv1b_),by(yearh2 distcd)
gen CFiv2b_ = alimargin>=-0.02 & alimargin<=0.02
egen CFiv2b=mean(CFiv2b_),by(yearh2 distcd)
ge turnout=votes/electors
drop ali CF*_ 
sort state2 ac_n year
gen change=0 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty!=pparty[_n-1]
egen dchange=mean(change),by(distcd year)
* Collapse to district level & aggregate
egen dturnout=mean(turnout),by(distcd yearh2)
keep  yearh2 state state2 distcd dist sparty newrule dchange aligns saligns CFiv1 CFiv2 CFiv1b CFiv2b dturnout month
keep if distcd~=distcd[_n-1] 
label var aligns "% seats in district politically aligned with state leader"
label var CFiv1 "% ACs where aligned party won marginally (max 3.5%)"
label var CFiv2 "% ACs where alignment outcome was a close call (-3.5/3.5%)"
label var CFiv1b "% ACs where aligned party won marginally (max 2%)"
label var CFiv2b "% ACs where alignment outcome was a close call (-2/2%)"
label var dturnout "Avg Voter turnout in district (across ACs)"
rename yearh2 year
rename aligns alignsh2
rename saligns salignsh2
rename sparty spartyh2
rename newrule newruleh2
rename dchange dchangeh2
rename CFiv1 CFiv1h2
rename CFiv2 CFiv2h2
rename CFiv1b CFiv1bh2
rename CFiv2b CFiv2bh2
rename dturnout dturnouth2
*Bihar-Jharkhand split:
replace state2="JH" if state2=="BH" & year==2000 & distcd>2000
sort state2 distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h2.dta,replace

*** FOR H3: POLITICAL YEAR JUL-JUN *** [REMOVE - NOT USED]
use /tera1/IndiaTeachers/AssemblyElec/x1999-2012_AsElec2_dists.dta,clear
sort yearh3 distcd
egen sparty=mode(pparty),by(yearh3 state2)
replace sparty="JMM" if state2=="JH" & yearh1==2009
gen ali= pparty==sparty
egen saligns=mean(ali),by(yearh3 state2)
sort state2 yearh3
gen newrule=1 if state2==state2[_n-1] & yearh3~=yearh3[_n-1] & sparty~=sparty[_n-1]
replace newrule=0 if state2==state2[_n-1] & yearh3~=yearh3[_n-1] & sparty==sparty[_n-1]
replace newrule=newrule[_n-1] if yearh3==yearh3[_n-1] & state2==state2[_n-1] & newrule==.
egen aligns=mean(ali),by(yearh3 distcd)
gen alimargin=margin if pparty==sparty
replace alimargin=-margin if loserparty==sparty
gen CFiv1_ = alimargin>0 & alimargin<=0.035
egen CFiv1=mean(CFiv1_),by(yearh3 distcd)
gen CFiv2_ = alimargin>=-0.035 & alimargin<=0.035
egen CFiv2=mean(CFiv2_),by(yearh3 distcd)
gen CFiv1b_ = alimargin>0 & alimargin<=0.02
egen CFiv1b=mean(CFiv1b_),by(yearh3 distcd)
gen CFiv2b_ = alimargin>=-0.02 & alimargin<=0.02
egen CFiv2b=mean(CFiv2b_),by(yearh3 distcd)
ge turnout=votes/electors
drop ali CF*_ 
sort state2 ac_n year
gen change=0 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty==pparty[_n-1]
replace change=1 if ac_n==ac_n[_n-1] & year<2008 & year[_n-1]<2008 & pparty!=pparty[_n-1]
egen dchange=mean(change),by(distcd year)
* Collapse to district level & aggregate
egen dturnout=mean(turnout),by(distcd yearh3)
keep  yearh3 state state2 distcd dist sparty newrule dchange aligns saligns CFiv1 CFiv2 CFiv1b CFiv2b dturnout month
keep if distcd~=distcd[_n-1] 
label var aligns "% seats in district politically aligned with state leader"
label var CFiv1 "% ACs where aligned party won marginally (max 3.5%)"
label var CFiv2 "% ACs where alignment outcome was a close call (-3.5/3.5%)"
label var CFiv1b "% ACs where aligned party won marginally (max 2%)"
label var CFiv2b "% ACs where alignment outcome was a close call (-2/2%)"
label var dturnout "Avg Voter turnout in district (across ACs)"
rename yearh3 year
rename aligns alignsh3
rename saligns salignsh3
rename sparty spartyh3
rename newrule newruleh3
rename dchange dchangeh3
rename CFiv1 CFiv1h3
rename CFiv2 CFiv2h3
rename CFiv1b CFiv1bh3
rename CFiv2b CFiv2bh3
rename dturnout dturnouth3
*Bihar-Jharkhand split:
replace state2="JH" if state2=="BH" & year==2000 & distcd>2000
sort state2 distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h3.dta,replace

**************************************************
* CONSTRUCT POLITICAL MATRIX FOR MERGING TO DISE *
**************************************************
* Create all Year-distcd cells, merge results, and fill the matrix
clear
use /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics.dta
keep state2 distcd
duplicates drop
drop if distcd==.
sort distcd
gen year=1999
* 14 years 600 dists = 8400 obs
set obs 8400
replace distcd=distcd[_n-600] if distcd==.
replace state2=state2[_n-600] if state2==""
replace year=year[_n-600]+1 if year==.
sort state2 distcd year
merge state2 distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics.dta
* some obs don't have distcd
*          1 |      6,894       81.96       81.96
*          2 |         11        0.13       82.09
*          3 |      1,506       17.91      100.00
drop if _merge==2
drop state _merge
* I merge the election year from another file since the above may have missing info for some districts
sort state2 year
merge state2 year using /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elec.dta
* only AR doesn't merge (not in master data)
drop if _merge==2
* variable for electoral cycle (0=election year)
gen elecyr=0 if _merge==3
sort distcd year
* note that there are a few exceptions to length of 5 years between elections:
* JK0208(6), HP0307(4), HY0509(4), MR0002(2), JH0509(4), OR0004(4), KT0408(4)
* always call year prior to election '4', and election year '0'
replace elecyr=4 if elecyr[_n+1]==0 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n-1]==0 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=3 if elecyr[_n+1]==4 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=2 if elecyr[_n-1]==1 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=2 if elecyr[_n+1]==3 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n+1]==2 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=3 if elecyr[_n-1]==2 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=4 if elecyr[_n-1]==3 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
label var elecyr "Years from election (0=election year, 4=pre-election)"

* IV:'exogenous' or expected election cycle, based on latest election
gen eleciv=0 if elecyr==0 
replace eleciv=eleciv[_n-1]+1 if year==year[_n-1]+1 & distcd==distcd[_n-1] & eleciv==. 
replace eleciv=0 if eleciv==5
replace eleciv=1 if eleciv==6
replace eleciv=4 if eleciv[_n+1]==0 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=3 if eleciv[_n+1]==4 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=2 if eleciv[_n+1]==3 & eleciv==. & distcd==distcd[_n+1]
label var eleciv "IV for election year (0=election, 5=pre-elec)"

* Fill empty years
foreach var of varlist aligns saligns newrule CFiv1* CFiv2* ?turnout* dbigch dchange fems ivfem* res?? psc pst {
replace `var'=`var'[_n-1] if `var'==. & distcd==distcd[_n-1] & elecyr~=. & _merge==1
}
replace sparty=sparty[_n-1] if sparty=="" & distcd==distcd[_n-1] & elecyr~=.
* month of election to all years
replace month=month[_n-1] if month==. & month[_n-1]!=. & state2==state2[_n-1]

drop _merge
sort distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix.dta,replace

*NOTE: Do not use the IVs (eleciv0 and eleciv4) for h1 and h2 timings unless carefully checked:
*** FOR H1: POLITICAL YEAR OCT-SEP ***
use /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h1.dta,clear
keep state2 distcd
duplicates drop
drop if distcd==.
sort distcd
gen year=1999
set obs 8400
replace distcd=distcd[_n-600] if distcd==.
replace state2=state2[_n-600] if state2==""
replace year=year[_n-600]+1 if year==.
sort state2 distcd year
merge state2 distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h1.dta
drop if _merge==2
drop state _merge
rename year yearh1
sort state2 yearh1
merge state2 yearh1 using /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech1.dta
rename yearh1 year
drop if _merge==2
gen elecyr=0 if _merge==3
sort distcd year
replace elecyr=4 if elecyr[_n+1]==0 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n-1]==0 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=3 if elecyr[_n+1]==4 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=2 if elecyr[_n-1]==1 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=2 if elecyr[_n+1]==3 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n+1]==2 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=3 if elecyr[_n-1]==2 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=4 if elecyr[_n-1]==3 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
label var elecyr "Years from election (0=election year, 4=pre-election)"
gen eleciv=0 if elecyr==0 
replace eleciv=eleciv[_n-1]+1 if year==year[_n-1]+1 & distcd==distcd[_n-1] & eleciv==. 
replace eleciv=0 if eleciv==5
replace eleciv=1 if eleciv==6
replace eleciv=4 if eleciv[_n+1]==0 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=3 if eleciv[_n+1]==4 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=2 if eleciv[_n+1]==3 & eleciv==. & distcd==distcd[_n+1]
label var eleciv "IV for election year (0=election, 5=pre-elec)"
rename elecyr elecyrh1
rename eleciv elecivh1
foreach var of varlist alignsh1 salignsh1 newruleh1 dbigchh1 dchangeh1 ?turnouth1 {
replace `var'=`var'[_n-1] if `var'==. & distcd==distcd[_n-1] & elecyr~=. & _merge==1
}
replace spartyh1=spartyh1[_n-1] if spartyh1=="" & distcd==distcd[_n-1] & elecyr~=.
drop _merge month dist state2 
sort distcd year 
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h1.dta,replace

*** FOR H2: POLITICAL YEAR APR-MAR *** [REMOVE - NOT USED]
use /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h2.dta,clear
keep state2 distcd
duplicates drop
drop if distcd==.
sort distcd
gen year=1999
set obs 8400
replace distcd=distcd[_n-600] if distcd==.
replace state2=state2[_n-600] if state2==""
replace year=year[_n-600]+1 if year==.
sort state2 distcd year
merge state2 distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h2.dta
drop if _merge==2
drop state _merge
rename year yearh2
sort state2 yearh2
merge state2 yearh2 using /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech2.dta
rename yearh2 year
drop if _merge==2
gen elecyr=0 if _merge==3
sort distcd year
replace elecyr=4 if elecyr[_n+1]==0 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n-1]==0 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=3 if elecyr[_n+1]==4 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=2 if elecyr[_n-1]==1 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=2 if elecyr[_n+1]==3 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n+1]==2 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=3 if elecyr[_n-1]==2 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=4 if elecyr[_n-1]==3 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
label var elecyr "Years from election (0=election year, 4=pre-election)"
gen eleciv=0 if elecyr==0 
replace eleciv=eleciv[_n-1]+1 if year==year[_n-1]+1 & distcd==distcd[_n-1] & eleciv==. 
replace eleciv=0 if eleciv==5
replace eleciv=1 if eleciv==6
replace eleciv=4 if eleciv[_n+1]==0 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=3 if eleciv[_n+1]==4 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=2 if eleciv[_n+1]==3 & eleciv==. & distcd==distcd[_n+1]
label var eleciv "IV for election year (0=election, 5=pre-elec)"
rename elecyr elecyrh2
rename eleciv elecivh2
foreach var of varlist alignsh2 salignsh2 newruleh2 dchangeh2 CFiv1* CFiv2* ?turnouth2 {
replace `var'=`var'[_n-1] if `var'==. & distcd==distcd[_n-1] & elecyr~=. & _merge==1
}
replace spartyh2=spartyh2[_n-1] if spartyh2=="" & distcd==distcd[_n-1] & elecyr~=.
drop _merge month dist state2
sort distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h2.dta,replace

*** FOR H3: POLITICAL YEAR JUL-JUN *** [REMOVE - NOT USED]
use /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h3.dta,clear
keep state2 distcd
duplicates drop
drop if distcd==.
sort distcd
gen year=1999
set obs 8400
replace distcd=distcd[_n-600] if distcd==.
replace state2=state2[_n-600] if state2==""
replace year=year[_n-600]+1 if year==.
sort state2 distcd year
merge state2 distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPolitics_h3.dta
drop if _merge==2
drop state _merge
rename year yearh3
sort state2 yearh3
merge state2 yearh3 using /tera1/IndiaTeachers/AssemblyElec/1999-2012_state-year-elech3.dta
rename yearh3 year
drop if _merge==2
gen elecyr=0 if _merge==3
sort distcd year
replace elecyr=4 if elecyr[_n+1]==0 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n-1]==0 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=3 if elecyr[_n+1]==4 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=2 if elecyr[_n-1]==1 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=2 if elecyr[_n+1]==3 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=1 if elecyr[_n+1]==2 & distcd==distcd[_n+1] & year==year[_n+1]-1 & elecyr==.
replace elecyr=3 if elecyr[_n-1]==2 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
replace elecyr=4 if elecyr[_n-1]==3 & distcd==distcd[_n-1] & year==year[_n-1]+1 & elecyr==.
label var elecyr "Years from election (0=election year, 4=pre-election)"
gen eleciv=0 if elecyr==0 
replace eleciv=eleciv[_n-1]+1 if year==year[_n-1]+1 & distcd==distcd[_n-1] & eleciv==. 
replace eleciv=0 if eleciv==5
replace eleciv=1 if eleciv==6
replace eleciv=4 if eleciv[_n+1]==0 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=3 if eleciv[_n+1]==4 & eleciv==. & distcd==distcd[_n+1]
replace eleciv=2 if eleciv[_n+1]==3 & eleciv==. & distcd==distcd[_n+1]
label var eleciv "IV for election year (0=election, 5=pre-elec)"
rename elecyr elecyrh3
rename eleciv elecivh3
foreach var of varlist alignsh3 salignsh3 newruleh3 dchangeh3 CFiv1* CFiv2* ?turnouth3 {
replace `var'=`var'[_n-1] if `var'==. & distcd==distcd[_n-1] & elecyr~=. & _merge==1
}
replace spartyh3=spartyh3[_n-1] if spartyh3=="" & distcd==distcd[_n-1] & elecyr~=.
drop _merge month dist state2
sort distcd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h3.dta,replace


** Merge all alternatives [leave alternative timings out for now]
use /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix.dta,clear
*sort distcd year
*merge distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h1.dta
*tab _merge
*drop _merge 
*sort distcd year
*merge distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h2.dta
*tab _merge
*drop _merge
*sort distcd year
*merge distcd year using /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_h3.dta
*tab _merge
*drop _merge 
*sort distcd year
*saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix.dta,replace

* version with state sorting, insead of district
gen statecd=floor(distcd/100)
sort statecd year
saveold /tera1/IndiaTeachers/AssemblyElec/2000-2012-DistrictPoliticsMatrix_statesort.dta,replace
