* This file is called by cycle_tch.do

* Produces Figure 2

*** Graph 1
use /tera1/IndiaTeachers/ResourceCycle/cycle_tch_reg.dta,clear
qui xtreg disap ed3 ed4 ed1 ed2 yd* if category<4 & outl==0 & age<=55 & age>=18, fe cluster(state)
outreg2 using /tera1/IndiaTeachers/ResourceCycle/ols, replace wide 10pct bracket dec(3) fmt(g) keep(ed1 ed2 ed4 ed5)
parmest, label list(parm label estimate min* max* p) saving(results1, replace)
use /tera1/IndiaTeachers/ResourceCycle/results1, clear
drop if _n>4
replace label="-2" in 1
replace label="-1" in 2
replace label="+1" in 3
replace label="+2" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist label estimate stderr dof t p min95 max95 parm {
replace `var'=`var'[_n-1] if _n==5
replace `var'=`var'[_n-1] if _n==4
}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Year effects + Full data") legend(off) 
graph save /tera1/IndiaTeachers/ResourceCycle/Event1,replace

*** Graph 2
use /tera1/IndiaTeachers/ResourceCycle/cycle_tch_reg.dta,clear
qui xtreg disap ed3 ed4 ed1 ed2 yd* if category<4 & outl==0 & age<=55 & age>=18 & schi==7, fe cluster(state)
outreg2 using /tera1/IndiaTeachers/ResourceCycle/ols, append wide 10pct bracket dec(3) fmt(g) keep(ed1 ed2 ed4 ed5)
parmest, label list(parm label estimate min* max* p) saving(results2, replace)
use /tera1/IndiaTeachers/ResourceCycle/results2, clear
drop if _n>4
replace label="-2" in 1
replace label="-1" in 2
replace label="+1" in 3
replace label="+2" in 4

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-2 if parm==3
replace parm=-1 if parm==4

set obs 5
foreach var of varlist label estimate stderr dof t p min95 max95 parm {
replace `var'=`var'[_n-1] if _n==5
replace `var'=`var'[_n-1] if _n==4
}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==3
}
replace label="0" if _n==3

label define timing -2 "-2" -1 "-1" 0 "Election" 1 "+1" 2 "+2"
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-2(1)2))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Year effects + Balanced panel") legend(off)
graph save /tera1/IndiaTeachers/ResourceCycle/Event2,replace

*** Graph 3
use /tera1/IndiaTeachers/ResourceCycle/cycle_tch_reg.dta,clear
qui xtreg disap bef aft yd* if category<4 & outl==0 & age<=55 & age>=18, fe cluster(state)
outreg2 using /tera1/IndiaTeachers/ResourceCycle/ols, append wide 10pct bracket dec(3) fmt(g) keep(ed1 ed2 ed4 ed5)
parmest, label list(parm label estimate min* max* p) saving(results3, replace)
use /tera1/IndiaTeachers/ResourceCycle/results3, clear
drop if _n>2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
foreach var of varlist label estimate stderr dof t p min95 max95 parm {
replace `var'=`var'[_n-1] if _n==3
}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==2
}
replace label="0" if _n==2

label define timing -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Grouped years + Full data") legend(off) 
graph save /tera1/IndiaTeachers/ResourceCycle/Event3,replace

*** Graph 4
use /tera1/IndiaTeachers/ResourceCycle/cycle_tch_reg.dta,clear
qui xtreg disap bef aft yd* if category<4 & outl==0 & age<=55 & age>=18 & schi==7, fe cluster(state)
outreg2 using /tera1/IndiaTeachers/ResourceCycle/ols, append wide 10pct bracket dec(3) fmt(g) keep(ed1 ed2 ed4 ed5)
parmest, label list(parm label estimate min* max* p) saving(results4, replace)
use /tera1/IndiaTeachers/ResourceCycle/results4, clear
drop if _n>2

encode parm, gen(parm2)
drop parm
rename parm2 parm

replace parm=-1 if parm==2

set obs 3
foreach var of varlist label estimate stderr dof t p min95 max95 parm {
replace `var'=`var'[_n-1] if _n==3
}
foreach var of varlist estimate stderr dof t p min95 max95 parm {
replace `var'=0 if _n==2
}
replace label="0" if _n==2

label define timing -1 "Before" 0 "Election" 1 "After" 
label values parm timing

label variable estimate "Coefficient"
label variable min95 "Lower 95% CI "
label variable max95 "Upper 95% CI"
twoway (scatter estimate parm, mcolor(black) msymbol(square) msize(small) yline(0) xsc(r(-1(1)1))) (rcap min95 max95 parm, lcolor(black)), xlabel(, valuelabels angle(0)) xtitle("") title("Grouped years + Balanced panel") legend(off)  
graph save /tera1/IndiaTeachers/ResourceCycle/Event4,replace

cd /tera1/IndiaTeachers/ResourceCycle/
gr combine Event1.gph Event2.gph Event3.gph Event4.gph, col(2)
graph export /tera1/IndiaTeachers/ResourceCycle/Events_all.tif,replace

